Name: yaws
Version: 1.84
Release: alt2
Packager: Sergey Shilov <hsv@altlinux.org>
Group: System/Servers
License: BSD
Url: http://yaws.hyber.org/

Provides: %name = %version-%release

Requires: %name-server %name-dyncontent-example %name-doc-pdf

BuildRequires: erlang-devel erlang-otp-devel latex2html tetex-dvips tetex-latex libpam-devel

Source0: %name-%version.tar.gz
Source1: yaws.init.d
Source2: yaws.conf


Summary: Yaws webserver virtual package

%description
Yaws - virtual package
to easy select yaws packages during install.


%package server
Summary: A high performance HTTP 1.1 webserver
Group: System/Servers
Requires: erlang-otp
Provides: %name-server = %version-%release

%description server
Yaws is a HTTP high perfomance 1.1 webserver particularly
well suited for dynamic-content webapplications. Two separate
modes of operations are supported.

* Standalone mode where Yaws runs as a regular webserver daemon.
  This is the default mode.
* Embedded mode where Yaws runs as an embedded webserver in another
  erlang application


%package  dyncontent-example
Summary: Yaws online manual as dynamic-content example
Group: Development/Documentation
BuildArch: noarch
Requires: %name-server = %version-%release

%description dyncontent-example
The package contains Yaws online manual designed in dynamic-content *.yaws format.
After install Content is accessable by URL http://$HOST:8888 ( see /etc/yaws/yaws.conf for details ).


%package doc-pdf
Summary: Documentation for Yaws HTTP webserver in PDF format
Group: Development/Documentation
BuildArch: noarch
Requires: %name-server = %version-%release

%description doc-pdf
The package contains a Claes Wikstroms - "Yaws - Yet Another Web Server" Book in PDF format.
This Book is a part of official Yaws sources from http://yaws.hyber.org/


%prep
%setup -q
install -p -m755 %_sourcedir/yaws.init.d .
install -p -m644 %_sourcedir/yaws.conf .

%build
# Server
%autoreconf -f
export CFLAGS="-fno-strict-aliasing"
export CXXFLAGS="-fno-strict-aliasing"
%configure \
    --with-ssl=%prefix \
    --with-defaultcharset=UTF-8 \
    --localstatedir=%_localstatedir
%__make  BINDIR=%_bindir LIBDIR=%_libexecdir 
# Documetation
%__make BINDIR=%_bindir LIBDIR=%_libdir docs

%install
%makeinstall BINDIR=%_bindir LIBDIR=%_libexecdir  INSTALL_PREFIX=%buildroot DESTDIR=%buildroot
# Remove not needed (created by makeinstall) dirs
%__rm -Rf %buildroot/%_sysconfdir/init.d
%__rm -Rf %buildroot/usr/etc
%__rm -Rf %buildroot/%_var/lib/log
#
%ifarch x86_64
%__mkdir_p %buildroot/%_libdir/pkgconfig
%__mv -f %buildroot/%_libexecdir/pkgconfig/* %buildroot/%_libdir/pkgconfig/
%__rm -Rf %buildroot/%_libexecdir/pkgconfig
%endif
%__mkdir_p %buildroot/%_initrddir
%__install -m755 yaws.init.d %buildroot/%_initrddir/%name
%__install -m640 yaws.conf %buildroot/%_sysconfdir/%name
%__mkdir_p %buildroot/%_docdir/%name-%version
%__install -m644 README ChangeLog %buildroot/%_docdir/%name-%version
%__mkdir_p %buildroot/%_localstatedir/%name/dyncontent-example
%__mv -f %buildroot/%_localstatedir/%name/www/* %buildroot/%_localstatedir/%name/dyncontent-example
# Create default log dir
%__mkdir_p %buildroot/%_logdir/%name

%post  server
%post_service %name

%preun server 
%preun_service %name
%__rm -f %_logdir/%name/*

%post dyncontent-example
# Add dyncontent-example section to Yaws config  if it NOT exists
egrep -q '/var/lib/yaws/dyncontent-example' %_sysconfdir/%name/yaws.conf ||
echo "
<server $HOSTNAME >
        port = 8888
        listen = 0.0.0.0
        docroot = /var/lib/yaws/dyncontent-example
        appmods = <cgi-bin, yaws_appmod_cgi>
</server>
">>%_sysconfdir/%name/yaws.conf

%postun dyncontent-example
# Delete dyncontent-example section from config
RR=`cat %_sysconfdir/%name/yaws.conf | \
    egrep -n '<server|\/var\/lib\/yaws\/dyncontent-example|server>' | \
    egrep -B1 -A1 '\/var\/lib\/yaws\/dyncontent-example' | \
    awk -F: '{ print $1 }' | \
    xargs echo | awk '{ printf "%s,%s", $1, $3 } '`
[ $RR == "," ] || sed -i -e "$RR d " %_sysconfdir/%name/yaws.conf


%files

%files server
%_bindir/*
%config(noreplace) %_sysconfdir/%name/*
%_initrddir/%name
%_libexecdir/%name
%_localstatedir/%name/ebin
%_localstatedir/%name/www
%_man1dir/*
%_man5dir/*
%_libdir/pkgconfig/*
%_docdir/%name-%version/README
%_docdir/%name-%version/ChangeLog
%_logdir/%name

%files doc-pdf
%_docdir/%name-%version/%name.pdf

%files dyncontent-example
%_localstatedir/%name/dyncontent-example

%changelog
* Thu Jul 30 2009 Sergey Shilov <hsv@altlinux.org> 1.84-alt2
- fix x86_64 build.

* Tue Jul 28 2009 Sergey Shilov <hsv@altlinux.org> 1.84-alt1
- initial build.


